#pragma once

#include "ofMain.h"
#include "ofxAssimpModelLoader.h"
#include "ofxUi.h"
#include "Comercios.h"
#include "Limites.h"
#include "Grupos.h"
#include "RAlimentar.h"

class ofApp : public ofBaseApp{
    
    Grupos grp;
    vector<Grupos> Vgrps;
    
    Comercios cmr;
    vector<Comercios> Vcmrs;
    
    RAlimentar RAlim; // Ramo Alimentar
    vector<RAlimentar> VRAlim; // Vetor Ramo Alimentar

	public:
		void setup();
		void update();
		void draw();

		void keyPressed(int key);
		void keyReleased(int key);
		void mouseMoved(int x, int y );
		void mouseDragged(int x, int y, int button);
		void mousePressed(int x, int y, int button);
		void mouseReleased(int x, int y, int button);
		void mouseEntered(int x, int y);
		void mouseExited(int x, int y);
		void windowResized(int w, int h);
		void dragEvent(ofDragInfo dragInfo);
		void gotMessage(ofMessage msg);
    
        void guiEvent(ofxUIEventArgs &e);
        void exit();
    
    ofxUICanvas *gui;
    ofxUIDropDownList *ddl;
    ofxUITabBar *guiTabBar;
    
    ofxUISuperCanvas *gui2;
    ofxUIDropDownList *ddl2;
    ofxUITabBar *guiTabBar2;


    
    ofxAssimpModelLoader model;
    ofxAssimpModelLoader chao;
    
    
    ofMaterial materialPlane; // define material

    
    bool g_onoff_menuRAlim; // menu Ramo alimentar
    
    
    bool g_onoff_nome = false; // nome ponto
    bool g_onoff_cmr = false; // comercio
    
    
    //  textura de chao
    ofTexture chaoTexture, foto1, foto2, foto3, foto4;
    ofPoint points[4];
    int cornerIndex = 0;
    
    
    ofMesh mesh;
    ofLight	light1,light2;
    
    ofVec3f center;
    ofVec3f camera;
    //ofVec4f v4; // vector coordenadas
    ofVec4f vetor; // vector p oscil com coords
    
    ofEasyCam cam; // add mouse controls for camera movement
    //    ofEasyCam lookat;
    
    string linha, nome, loc, act;
    string strg_grupo, strg_ramo, strg_loc, strg_prop, strg_ativ, strg_nome;
    
    int numlinha, conta;
    
    string GRPSelected, RAMSelected;
    
    float g_cartXa, g_cartYa, g_cartXb, g_cartYb;
    
    float g_movx;
    float g_scale = 3.4;
    
    ofPoint g_camsmooth, g_camraw, g_camlook;
    int g_modomovimento = 0;
    int g_clicAltitude = 0;
    float g_camDolly = 100;
    int g_switchLight = 0;
    
    ofPoint atten; // p teste
    float g_dimmer1 = 1;
    float g_dimmer2 = 1;
    
    
    //    float time = 0;
    //    float beginning = 0;
    //    float change = 0.002;
    //    float duration = 1000;
    
    // float val;
    
    
    // easing rotacao objeto
    //    float g_easing = 0.05;
    // translat objs...
    //    float g_tx = 234;
    //    float g_ty = -20;
    //    float g_tz = -3.0; // junto a chao
    //    float g_rot = 119.5;
    
    // oscill
    //    float amplitude = 1.5;
    //    float period = 120;
    //    float ox;
    //    float oy;
    //    float oz;
    
    //    float oscX;
    //    float oscY;
    //    float amplX;
    //    float amplY;
    
    // perlin
    //    float n;
    
};
