//
//  Comercios.h
//  mapa_assimp_evr
//

//

#ifndef Comercios_h
#define Comercios_h

#include "ofMain.h"

class Comercios{
    
public:
    
    // ofPoint pos;
    ofColor cor;
    string nomes, loc, activi;
    
    int onoff_drawNome, onoff_drawComr;
    float nivelZ = 4;
    
    // amplitude de oscilacao
    float amplX, amplY, oscX, oscY;
    //    float amplitude = 1.5;
    float period = 180;
    ofVec4f vetor;
    ofPoint centrorua;
    ofPoint raios;
    
    // ofTexture pontoluz;
    
    ofPoint pta;
    ofPoint ptb;
    ofPoint ptcurrent;
    ofPoint ptvel;
    int qualatrai=0;
    
    
    void setup (string strg_nome, string strg_loc, float Xa, float Ya, float Xb, float Yb){ // (x,y,z,w) _______________________________________
        
        onoff_drawComr = 1;
        onoff_drawNome = 0;
        
        // ofLoadImage(pontoluz, "dot.png");
        
        // pos.set (ofRandom(Xa), Ya);
        vetor.set( Xa, Ya, Xb, Yb); // (x, y, w, z) para vetor de rua (do GPS)
        
        //        centrorua.x = (Xa + Xb)*0.5;
        //        centrorua.y = (Ya + Yb)*0.5;
        //
        //        ofPoint pta (Xa, Ya);
        //
        //        raios.x = pta.distance(centrorua);
        //        raios.y = pta.distance(centrorua);
        
        pta.set(Xa,Ya);
        ptb.set(Xb,Yb);
        ptcurrent = ptb;
        ptcurrent.x += ofRandom(-5,5);
        ptcurrent.y += ofRandom(-5,5);
        
        
        nomes = strg_nome;
        loc = strg_loc;
        
        //        cout << " Xa= " << Xa << " Ya= " << Ya <<" Xb= " << Xb << " Yb= " << Yb << endl;
        
    }
    
    
    void update(bool onoff_nome, bool on_off_cmr){ // _______________________________________
        
        
        //         oscilacao por vetor de subracao entre cordenadas (do GPS)
        if (on_off_cmr == true){
            
            ofPoint atractor;
            if(qualatrai==0){
                atractor = pta;
            }else {
                atractor = ptb;
            }
            
            // 1 forca
            ofPoint delta = atractor - ptcurrent;
            float dist = delta.length();
            
            if(dist < 1){
                if(qualatrai==0) qualatrai=1;
                else qualatrai = 0;
            }
            // if(dist > 0.02) delta.normalize();
            delta *= 0.005;
            
            ptvel += delta;
            ptvel.limit(0.2);
            
            ptcurrent += ptvel;
            
            
            
            
            /*
             amplX = (vetor.x - vetor.z); // inclinacao em X
             amplY = (vetor.y - vetor.w); // inclinacao em Y
             
             
             // cria valor oscilacao com amplitude da inclinacao em X e em Y
             oscX = amplX/2 * cos(TWO_PI * ofGetFrameNum() / period);
             oscY = amplY/2 * sin(TWO_PI * ofGetFrameNum() / period);
             
             cout <<"nome= " << loc << " | amplX= " << amplX << " | amplY= " << amplY <<endl;
             */
            onoff_drawComr = 1;
        } else { onoff_drawComr = 0; }
        
        
        if (onoff_nome == true){
            onoff_drawNome = 1;
        } else { onoff_drawNome = 0; }
        
        //        cout << "onoff_nome = " << onoff_nome << endl;
        
    }
    
    void draw(){ // _______________________________________
        
        if (onoff_drawComr == 1){
            
            // PONTOS (cord vect)
            ofSetColor(100, 100, 200); // azul
            ofDrawBox(ptcurrent.x, ptcurrent.y, nivelZ, 0.5);
            
            //ofSetColor(255);
            //pontoluz.draw(ptcurrent.x, ptcurrent.y, nivelZ, 0.5, 0.5);
            
            
            
            // vetores de verificacao
            ofSetColor(255, 255, 100);
            
            //            ofDrawBitmapString( ofToString( loc, 2), vetor.x, vetor.y-1.5, nivelZ/2);
            //            ofDrawBitmapString( " A " + ofToString(vetor.x, 2) + " | " + ofToString(vetor.y, 2) , vetor.x, vetor.y, nivelZ/2);
            //            ofDrawBitmapString( " B " + ofToString(vetor.z, 2) + " | " + ofToString(vetor.w, 2) , vetor.w, vetor.z, nivelZ/2);
            // ofDrawSphere(vetor.w, vetor.z, nivelZ/2, 0.3);
            ofDrawLine(vetor.x, vetor.y, nivelZ/2, vetor.z, vetor.w, nivelZ/2);
            
            //            if (onoff_nome == 1){
            ////        ofDrawBitmapString( nomes, vetor.x + oscX, vetor.y + oscY);
            //        ofDrawBitmapString(   loc,   vetor.x + oscX, vetor.y + oscY);
            //            }
        }
        
        if (onoff_drawNome == 1 ){
            ofSetColor(100, 100, 100);
            //            ofDrawBitmapString(   loc     , (vetor.x - amplX/2) + oscX, (vetor.y - amplY/2) + oscY);
            ofDrawBitmapString(   loc   , ptcurrent.x, ptcurrent.y, nivelZ);
        }
        
        //cout << "onoff_drawNome = " << onoff_drawNome << endl;
        
    }
    
    
    
};

#endif /* Comercios_h */

